package matsubara.gear;

import java.awt.Color;
import java.awt.Graphics;

/**
 * <p>^Cg:  Gear</p>
 * </p>:    ʓIȎ</p>
 * <p>쌠: Copyright (c) 2002 m.matsubara </p>
 * @author m.matsubara
 * @version 1.0
 */
public class Gear extends GearBase {

  int m_nGearCount = 50;
  int m_nGearDepth = 4;

  public Gear() {
  }
  /**
   * MAIuWFNg
   * @param nPosX XW
   * @param nPosY YW
   * @param rSize a
   * @param nGearCount MA̖̎
   * @param nGearDepth MA̎̐[
   */
  public Gear(int nPosX, int nPosY, double rSize, int nGearCount, int nGearDepth) {
    setPosX(nPosX);
    setPosY(nPosY);
    setSize(rSize);
    setGearCount(nGearCount);
    setGearDepth(nGearDepth);
  }

  /**
   * MA̖̎擾
   * @return MA̖̎
   */
  public int getGearCount() {
    return m_nGearCount;
  }
  /**
   * MA̖̎ݒ
   * @param newGearCount VMA̖̎
   */
  public void setGearCount(int newGearCount) {
    m_nGearCount = newGearCount;
  }
  /**
   * MA̎̐[擾
   * @return MA̎̐[
   */
  public int getGearDepth() {
    return m_nGearDepth;
  }
  /**
   * MA̎̐[ݒ
   * @param newGearDepth VMA̎̐[
   */
  public void setGearDepth(int newGearDepth) {
    m_nGearDepth = newGearDepth;
  }

  /**
   * MA`
   * @param g `Ɏg Graphics IuWFNg
   */
  public void draw(Graphics g) {
    int[] nxX = new int[4], nxY = new int[4];
    double rGearAngle;  //  ЂƂ̎̊pxiWAj
    double rIdx;
    double rSizeH = m_rSize + (double)m_nGearDepth / 2;  //  MA̎R̍
    double rSizeL = m_rSize - (double)m_nGearDepth / 2;  //  MA̒J̍
    rGearAngle = 2 * Math.PI / m_nGearCount;  //  1̃MÅpx
    nxX[3] = getPosX();
    nxY[3] = getPosY();

    //  ~iColor1j
    g.setColor(m_color1);
    //  ̒JP
    nxX[2] = rotateX(rSizeL, 0);
    nxY[2] = rotateY(rSizeL, 0);
    for (rIdx = 0.0; rIdx < Math.PI - 0.000001; rIdx += rGearAngle) {
      //  ̒JP
      nxX[0] = nxX[2];
      nxY[0] = nxY[2];
      //  ̎R
      nxX[1] = rotateX(rSizeH, rIdx + rGearAngle / 2);
      nxY[1] = rotateY(rSizeH, rIdx + rGearAngle / 2);
      //  ̒JQ
      nxX[2] = rotateX(rSizeL, rIdx + rGearAngle);
      nxY[2] = rotateY(rSizeL, rIdx + rGearAngle);
      g.fillPolygon(nxX, nxY, 4);
    }
    g.fillArc(m_nPosX - (int)rSizeL, m_nPosY - (int)rSizeL, (int)(rSizeL * 2), (int)(rSizeL * 2), 180 - (int)(m_rAngle / (2 * Math.PI) * 360), 180);

    //  ~iColor2j
    g.setColor(m_color2);
    if (getGearCount() % 2 == 1) {
      //  ̐̂ƂA̒ŐF邽߂̑Ώ
      nxX[0] = rotateX(rSizeL - 1, rIdx - rGearAngle / 2);
      nxY[0] = rotateY(rSizeL - 1, rIdx - rGearAngle / 2);
      g.fillPolygon(nxX, nxY, 4);
    }
    //  ̒JQ
    nxX[2] = rotateX(rSizeL, rIdx);
    nxY[2] = rotateY(rSizeL, rIdx);
    for (rIdx = rIdx; rIdx < 2 * Math.PI - 0.000001; rIdx += rGearAngle) {
      //  ̒JP
      nxX[0] = nxX[2];
      nxY[0] = nxY[2];
      //  ̎R
      nxX[1] = rotateX(rSizeH, rIdx + rGearAngle / 2);
      nxY[1] = rotateY(rSizeH, rIdx + rGearAngle / 2);
      //  ̒JQ
      nxX[2] = rotateX(rSizeL, rIdx + rGearAngle);
      nxY[2] = rotateY(rSizeL, rIdx + rGearAngle);
      g.fillPolygon(nxX, nxY, 4);
    }
    g.fillArc(m_nPosX - (int)rSizeL, m_nPosY - (int)rSizeL, (int)(rSizeL * 2), (int)(rSizeL * 2), 360 - (int)(m_rAngle / (2 * Math.PI) * 360), 180);

    //  MA̎
    int nAxles = 14;
    if (getSize() < 14)
      nAxles = (int)getSize(); //  MAꍇ͔aƓ傫

    g.setColor(Color.darkGray);
    g.fillArc(m_nPosX - nAxles / 2, m_nPosY - nAxles / 2, nAxles, nAxles, 0, 360);
    g.setColor(Color.black);
    g.drawArc(m_nPosX - nAxles / 2, m_nPosY - nAxles / 2, nAxles, nAxles, 0, 360);
  }
}