package matsubara.plageartest;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;

import matsubara.gear.*;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.beans.*;
import javax.swing.event.*;

class PlaGearRunThread extends Thread {
  private PlaGearTest m_applet;
  private volatile boolean m_bStopRequest = false;

  /**
   * 䂷vl^MA̓ǗXbh
   * @param applet vl^MAV~[^Avbg̖{
   */
  PlaGearRunThread(PlaGearTest applet) {
    m_applet = applet;
  }
  /**
   * Xbh{
   */
  public void run() {
    long nSleep;
    java.util.Date date, date2, date3;
    date = new java.util.Date();
    date3 = new java.util.Date();
    Graphics graphics = m_applet.getGraphics();
    while (m_bStopRequest == false) {
      try {
        long nInterval = date3.getTime() - date.getTime();
//        m_applet.lbDebug.setText(String.valueOf(nInterval != 0 ? 1000 / nInterval : 0) + " fps");

        date = date3;
        m_applet.move(nInterval);
        m_applet.draw(m_applet.getGraphics());
        date2 = new java.util.Date();
        nSleep = 50 - (date2.getTime() - date.getTime());
        if (nSleep < 10)
          nSleep = 10;
        sleep(nSleep);
      }
      catch (Exception e) {
      }
      date3 = new java.util.Date();
    }
  }
  /**
   * Xbh̒~v𔭍s
   */
  public void stopRequest() {
    m_bStopRequest = true;
  }
}



/**
 * ^Cg:
 * : VԃV~[^
 * 쌠:   Copyright (c) 2002
 * @author matsubara masakazu
 * @version 1.0
 */
public class PlaGearTest extends Applet {
  PlanetaryGear m_plaGear = null;
  BufferedImage m_img = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
  PlaGearRunThread m_threadRun;
  boolean m_bSliderOperation = false;


  boolean isStandalone = false;
  JPanel jPanel1 = new JPanel();
  JSlider sliRingGear = new JSlider();
  JSlider sliPlanetaryCarrier = new JSlider();
  JSlider sliSunGear = new JSlider();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JPanel jPanel2 = new JPanel();
  JLabel jLabel4 = new JLabel();
  JTextField txRingGear = new JTextField();
  JLabel jLabel5 = new JLabel();
  JTextField txSunGear = new JTextField();
  JLabel jLabel6 = new JLabel();
  JTextField txPinionGear = new JTextField();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JButton btGearChange = new JButton();
  JLabel jLabel7 = new JLabel();
  JTextField txPinionGearNumber = new JTextField();
  JLabel lbStatus = new JLabel();
  JPanel pnlPlanetaryGear = new JPanel();
  JLabel lbRingGearSpeed = new JLabel();
  JLabel lbPlanetaryCarrerSpeed = new JLabel();
  JLabel lbSunGearSpeed = new JLabel();
  JButton btRingGearStop = new JButton();
  JButton btPlaCarrierStop = new JButton();
  JButton btSunGearStop = new JButton();
  /**l̎擾*/
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  /**Avbg̍\z*/
  public PlaGearTest() {
  }
  /**Avbg̏*/
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**R|[lg̏*/
  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    jPanel1.setLayout(gridBagLayout1);
    sliPlanetaryCarrier.setMajorTickSpacing(2000);
    sliPlanetaryCarrier.setMaximum(10000);
    sliPlanetaryCarrier.setOrientation(JSlider.VERTICAL);
    sliPlanetaryCarrier.setPaintTicks(true);
    sliPlanetaryCarrier.setMinimum(-10000);
    sliPlanetaryCarrier.setMinorTickSpacing(1000);
    sliPlanetaryCarrier.setPaintLabels(true);
    sliPlanetaryCarrier.setValue(0);
    sliPlanetaryCarrier.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliPlanetaryCarrier_stateChanged(e);
      }
    });
    sliPlanetaryCarrier.setBackground(Color.white);
    sliPlanetaryCarrier.setMinimumSize(new Dimension(54, 120));
    sliPlanetaryCarrier.setOpaque(false);
    sliPlanetaryCarrier.setToolTipText("");
    sliRingGear.setMajorTickSpacing(2000);
    sliRingGear.setMaximum(10000);
    sliRingGear.setOrientation(JSlider.VERTICAL);
    sliRingGear.setPaintTicks(true);
    sliRingGear.setMinimum(-10000);
    sliRingGear.setMinorTickSpacing(1000);
    sliRingGear.setPaintLabels(true);
    sliRingGear.setValue(0);
    sliRingGear.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliRingGear_stateChanged(e);
      }
    });
    sliRingGear.setBackground(Color.white);
    sliRingGear.setMinimumSize(new Dimension(54, 120));
    sliRingGear.setOpaque(false);
    sliRingGear.setToolTipText("");
    sliSunGear.setMajorTickSpacing(2000);
    sliSunGear.setMaximum(10000);
    sliSunGear.setOrientation(JSlider.VERTICAL);
    sliSunGear.setPaintTicks(true);
    sliSunGear.setMinimum(-10000);
    sliSunGear.setMinorTickSpacing(1000);
    sliSunGear.setPaintLabels(true);
    sliSunGear.setValue(0);
    sliSunGear.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliSunGear_stateChanged(e);
      }
    });
    sliSunGear.setBackground(Color.white);
    sliSunGear.setMinimumSize(new Dimension(54, 120));
    sliSunGear.setOpaque(false);
    sliSunGear.setToolTipText("");
    jLabel1.setForeground(new Color(0, 191, 0));
    jLabel1.setText("OMA");
    jLabel2.setFont(new java.awt.Font("Dialog", 0, 8));
    jLabel2.setForeground(Color.red);
    jLabel2.setText("vl^LA");
    jLabel3.setForeground(Color.blue);
    jLabel3.setText("TMA@");
    jLabel4.setForeground(new Color(0, 191, 0));
    jLabel4.setText("OMA");
    txRingGear.setMinimumSize(new Dimension(63, 21));
    txRingGear.setText("78");
    txRingGear.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        txRingGear_keyReleased(e);
      }
    });
    jLabel5.setForeground(Color.blue);
    jLabel5.setToolTipText("");
    jLabel5.setText("TMA");
    txSunGear.setMinimumSize(new Dimension(63, 21));
    txSunGear.setPreferredSize(new Dimension(63, 21));
    txSunGear.setText("30");
    txSunGear.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        txSunGear_keyReleased(e);
      }
    });
    jLabel6.setBackground(Color.orange);
    jLabel6.setForeground(Color.darkGray);
    jLabel6.setOpaque(true);
    jLabel6.setToolTipText("");
    jLabel6.setText("sjIMA");
    txPinionGear.setMinimumSize(new Dimension(63, 21));
    txPinionGear.setText("24");
    jPanel2.setLayout(gridBagLayout2);
    btGearChange.setText("MAύX");
    btGearChange.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btGearChange_actionPerformed(e);
      }
    });
    jLabel7.setBackground(Color.orange);
    jLabel7.setForeground(Color.darkGray);
    jLabel7.setOpaque(true);
    jLabel7.setText("sjIMA");
    txPinionGearNumber.setMinimumSize(new Dimension(63, 21));
    txPinionGearNumber.setPreferredSize(new Dimension(63, 21));
    txPinionGearNumber.setText("4");
    lbStatus.setMinimumSize(new Dimension(50, 17));
    lbStatus.setPreferredSize(new Dimension(50, 17));
    lbStatus.setToolTipText("");
    jPanel1.setBackground(Color.white);
    jPanel2.setBackground(Color.white);
    this.setBackground(Color.white);
    pnlPlanetaryGear.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentResized(ComponentEvent e) {
        pnlPlanetaryGear_componentResized(e);
      }
    });
    pnlPlanetaryGear.setBackground(Color.white);
    lbRingGearSpeed.setForeground(new Color(0, 191, 0));
    lbRingGearSpeed.setHorizontalAlignment(SwingConstants.RIGHT);
    lbRingGearSpeed.setText("0rpm");
    lbPlanetaryCarrerSpeed.setForeground(Color.red);
    lbPlanetaryCarrerSpeed.setHorizontalAlignment(SwingConstants.RIGHT);
    lbPlanetaryCarrerSpeed.setText("0rpm");
    lbSunGearSpeed.setForeground(Color.blue);
    lbSunGearSpeed.setHorizontalAlignment(SwingConstants.RIGHT);
    lbSunGearSpeed.setText("0rpm");
    btRingGearStop.setText("@~@");
    btRingGearStop.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btRingGearStop_actionPerformed(e);
      }
    });
    btPlaCarrierStop.setText("@~@");
    btPlaCarrierStop.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btPlaCarrierStop_actionPerformed(e);
      }
    });
    btSunGearStop.setText("@~@");
    btSunGearStop.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btSunGearStop_actionPerformed(e);
      }
    });
    this.add(jPanel1, BorderLayout.EAST);
    jPanel1.add(sliRingGear,   new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 90));
    jPanel1.add(sliPlanetaryCarrier,   new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 90));
    jPanel1.add(sliSunGear,    new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 90));
    jPanel1.add(jLabel3,   new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel2,  new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel1,  new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(lbRingGearSpeed,  new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(lbPlanetaryCarrerSpeed,  new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(lbSunGearSpeed,     new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(btRingGearStop,      new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(btPlaCarrierStop, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(btSunGearStop, new GridBagConstraints(2, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    this.add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(jLabel4, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(txRingGear, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), -4, 0));
    jPanel2.add(jLabel5, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(txSunGear, new GridBagConstraints(3, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), -4, 0));
    jPanel2.add(jLabel6, new GridBagConstraints(4, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(txPinionGear, new GridBagConstraints(5, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), -4, 0));
    jPanel2.add(btGearChange, new GridBagConstraints(5, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(jLabel7, new GridBagConstraints(1, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(txPinionGearNumber, new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(lbStatus,   new GridBagConstraints(0, 2, 6, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    this.add(pnlPlanetaryGear,  BorderLayout.CENTER);
  }
  /**Avbg̊Jn*/
  public void start() {
    btGearChange.doClick();

    m_threadRun = new PlaGearRunThread(this);
    m_threadRun.start();
    showSpeed();
  }
  /**Avbg̒~*/
  public void stop() {
    m_threadRun.stopRequest();
  }
  /**Avbg̔j*/
  public void destroy() {
  }
  /**Main \bh*/
  public static void main(String[] args) {
    PlaGearTest applet = new PlaGearTest();
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame() {
      protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
          System.exit(0);
        }
      }
      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
    };
    frame.setTitle("VԁEeXgAvbg");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(640,480);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

  synchronized public void paint(Graphics g) {
    super.paint(g);
    if (m_plaGear != null) {
      Graphics gi = m_img.getGraphics();
      gi.setColor(Color.white);
      gi.fillRect(0, 0, m_img.getWidth(), m_img.getHeight());
      m_plaGear.draw(gi);
      try {
        g.drawImage(m_img, 0, 0, null);
      } catch (Exception e) {
      }
    }
  }

  synchronized public void move(long nTime) {
    m_plaGear.move(nTime / 200.0);
  }

  synchronized public void draw(Graphics g) {
    if (m_plaGear != null) {
      Graphics gi = m_img.getGraphics();
      gi.setColor(Color.white);
      gi.fillRect(0, 0, m_img.getWidth(), m_img.getHeight());
      m_plaGear.draw(gi);
      g.drawImage(m_img, 0, 0, null);
    }
  }

  synchronized public void resize() {
    if (pnlPlanetaryGear.getWidth() * pnlPlanetaryGear.getHeight() != 0)
      m_img = new BufferedImage(pnlPlanetaryGear.getWidth(), pnlPlanetaryGear.getHeight(), BufferedImage.TYPE_INT_RGB);
    else
      m_img = new BufferedImage(100, 100, BufferedImage.TYPE_INT_RGB);
    double rSize = ((pnlPlanetaryGear.getWidth() < pnlPlanetaryGear.getHeight()) ? pnlPlanetaryGear.getWidth() : pnlPlanetaryGear.getHeight()) * 4.0 / 5.0 / 2.0;
    if (rSize < 50.0)
      rSize = 50.0;
    if (m_plaGear != null) {
      m_plaGear.setPosX(pnlPlanetaryGear.getWidth() / 2);
      m_plaGear.setPosY(pnlPlanetaryGear.getHeight() / 2);
      m_plaGear.setSize(rSize);
    }
  }

  public void showSpeed() {
    lbRingGearSpeed.setText(String.valueOf((int)(m_plaGear.getRingGearSpeed() - m_plaGear.getRingGearSpeed() % 10)) + "rpm");
    lbPlanetaryCarrerSpeed.setText(String.valueOf((int)(m_plaGear.getPlaCarrierSpeed() - m_plaGear.getPlaCarrierSpeed() % 10)) + "rpm");
    lbSunGearSpeed.setText(String.valueOf((int)(m_plaGear.getSunGearSpeed() - m_plaGear.getSunGearSpeed() % 10)) + "rpm");
  }

  void btGearChange_actionPerformed(ActionEvent e) {
    int nRingGear = 0;
    int nSunGear = 0;
    int nPinionGear = 0;
    int nPinionGearNumber = 0;

    try {
      try {
        nRingGear = Integer.parseInt(txRingGear.getText());
        nSunGear = Integer.parseInt(txSunGear.getText());
        nPinionGear = Integer.parseInt(txPinionGear.getText());
        nPinionGearNumber = Integer.parseInt(txPinionGearNumber.getText());
      } catch (RuntimeException ex) {
      }
      if (nRingGear == 0)
        throw new Exception("OMA̒lsł");
      if (nSunGear == 0)
        throw new Exception("TMA̒lsł");
      if (nPinionGear == 0)
        throw new Exception("sjIMA̒lsł");
      if (nPinionGearNumber == 0)
        throw new Exception("sjIMA̒lsł");
      m_plaGear = new PlanetaryGear(130, 130, 100, nSunGear, nPinionGear, nRingGear, 6, nPinionGearNumber);
      lbStatus.setText("");
    }
    catch (Exception ex) {
      lbStatus.setText(ex.getMessage());
      ex.printStackTrace();
    }
    resize();
    sliRingGear.setValue(0);
    sliPlanetaryCarrier.setValue(0);
    sliSunGear.setValue(0);
    paint(getGraphics());
  }

  void sliRingGear_stateChanged(ChangeEvent e) {
    if (sliRingGear.hasFocus()) {
      m_plaGear.setRingGearSpeed(sliRingGear.getValue());
//      sliRingGear.setValue((int)(m_plaGear.getRingGearSpeed() + 0.5));
      sliPlanetaryCarrier.setValue((int)(m_plaGear.getPlaCarrierSpeed() + 0.5));
      sliSunGear.setValue((int)(m_plaGear.getSunGearSpeed() + 0.5));
      showSpeed();
    }
  }

  void sliPlanetaryCarrier_stateChanged(ChangeEvent e) {
    if (sliPlanetaryCarrier.hasFocus()) {
      m_plaGear.setPlaCarrierSpeed(sliPlanetaryCarrier.getValue());
//      sliRingGear.setValue((int)(m_plaGear.getRingGearSpeed() + 0.5));
//      sliPlanetaryCarrier.setValue((int)(m_plaGear.getPlaCarrierSpeed() + 0.5));
      sliSunGear.setValue((int)(m_plaGear.getSunGearSpeed() + 0.5));
      showSpeed();
    }
  }

  void sliSunGear_stateChanged(ChangeEvent e) {
    if (sliSunGear.hasFocus()) {
      m_plaGear.setSunGearSpeed(sliSunGear.getValue());
//      sliRingGear.setValue((int)(m_plaGear.getRingGearSpeed() + 0.5));
      sliPlanetaryCarrier.setValue((int)(m_plaGear.getPlaCarrierSpeed() + 0.5));
//      sliSunGear.setValue((int)(m_plaGear.getSunGearSpeed() + 0.5));
      showSpeed();
    }
  }

  void txRingGear_keyReleased(KeyEvent e) {
    try {
      int nRingGear = Integer.parseInt(txRingGear.getText());
      int nSunGear = Integer.parseInt(txSunGear.getText());
      txPinionGear.setText(String.valueOf((nRingGear - nSunGear) / 2));
    } catch (Exception ex) {
    }
  }

  void txSunGear_keyReleased(KeyEvent e) {
    try {
      int nRingGear = Integer.parseInt(txRingGear.getText());
      int nSunGear = Integer.parseInt(txSunGear.getText());
      txPinionGear.setText(String.valueOf((nRingGear - nSunGear) / 2));
    } catch (Exception ex) {
    }
  }

  void pnlPlanetaryGear_componentResized(ComponentEvent e) {
    resize();
  }

  void btRingGearStop_actionPerformed(ActionEvent e) {
    m_plaGear.setRingGearSpeed(0);
    sliRingGear.setValue((int)m_plaGear.getRingGearSpeed());
    sliSunGear.setValue((int)m_plaGear.getSunGearSpeed());
    showSpeed();
  }

  void btPlaCarrierStop_actionPerformed(ActionEvent e) {
    m_plaGear.setPlaCarrierSpeed(0);
    sliPlanetaryCarrier.setValue((int)m_plaGear.getPlaCarrierSpeed());
    sliSunGear.setValue((int)m_plaGear.getSunGearSpeed());
    showSpeed();
  }

  void btSunGearStop_actionPerformed(ActionEvent e) {
    m_plaGear.setSunGearSpeed(0);
    sliSunGear.setValue((int)m_plaGear.getSunGearSpeed());
    sliPlanetaryCarrier.setValue((int)m_plaGear.getPlaCarrierSpeed());
    showSpeed();
  }
}